#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "SaisirTexte_Entier.h"
#include "CreationClefsPubliquePrivee.h"
#include "PassageEntierCaractere.h"
extern void quitterExecution();

//(FILE *fichier,int *tabValeurCrypt,int nbreValeur,int *tour)
//affichage = "Entrez le nom du fichier dans lequel sauvegarder(avec arborescence et extension si vous le souhaitez)"

FILE * creerFichier(char *affichage){
	int test=0;
	char *nomfichier,*c;
	c=nomfichier;
	FILE * fichier=(FILE*)malloc(sizeof(FILE));
//	do{
		nomfichier=saisirTexte(affichage,stdin,250);
	/*	fichier=fopen(nomfichier,"r");
		
		if(fichier!=NULL){
			printf("IL y a erreur un fichier porte déjà ce nom!\n");
			printf("Si vous souhaitez l'écraser appuyez sur 0 sinon appuyez sur une autre touche\n");
			//quitterExecution();
			if((saisirEntier("",stdin))==0){
				fclose(fichier);
				FILE *fichier;
				fichier=fopen(nomfichier,"w");
				test=1;
			}
		}
		else{*/
			fichier=fopen(nomfichier,"w");
			test=1;
	//	}
		free(nomfichier);
		nomfichier=c;
//	}while(test==0);
	return(fichier);
}

char* chargerFichier(){
	FILE *fichier;
	char *nomfichier,*texte;
	
	nomfichier=saisirTexte("Veuillez entrez le nom du fichier que vous voulez charger\nCe nom contiendra également l'arborescence du fichier s'il n'est pas dans le workspace!!",stdin,255);
	fichier=fopen(nomfichier,"r");
	free(nomfichier);
	texte=saisirTexte("",fichier,3000);
	fclose(fichier);
	
	printf("Voici le texte qui a été chargé :\n%s\n",texte);
	return texte;
}

int chargerClefPriveeFichier(CLEFPRIVEE *clefprivee){
	FILE *fichier;
	char *nomfichier,*texte,*c;
	int  i,longueurTexteClair;
	
	nomfichier=saisirTexte("Veuillez entrez le nom du fichier que vous voulez charger\nCe nom contiendra également l'arborescence du fichier s'il n'est pas dans le workspace!!",stdin,255);
	fichier=fopen(nomfichier,"r");
	free(nomfichier);
	
	texte=saisirTexte("",fichier,300);     //On charge la longueur du texte clair
	longueurTexteClair=atoi(texte);
	free(texte);
	
	texte=saisirTexte("",fichier,300);     //On charge N
	clefprivee->N=atoi(texte);
	free(texte);
	
	texte=saisirTexte("",fichier,300);     //On charge Z
	clefprivee->Z=atoi(texte);
	free(texte);
	
	texte=saisirTexte("",fichier,300);     //On charge la taille de la suite
	clefprivee->tailleSuite=atoi(texte);
	free(texte);
	
	texte=saisirTexte("",fichier,300);     //On charge la suite permutee
	clefprivee->permutation=(int*)malloc(clefprivee->tailleSuite * sizeof(int));
	c=strchr(texte,' ');
	while(c!=NULL){
		*(clefprivee->permutation+i)=atoi(c);
		c=strchr(texte,' ');
	}
	free(texte);
	
	texte=saisirTexte("",fichier,300);     //On charge la suite supercroissante
	clefprivee->suiteSuperCroissante=(int*)malloc(clefprivee->tailleSuite * sizeof(int));
	c=strchr(texte,' ');
	while(c!=NULL){
		*(clefprivee->suiteSuperCroissante+i)=atoi(c);
		c=strchr(texte,' ');
	}
	free(texte);
	
	fclose(fichier);
	
	return(longueurTexteClair);
}

void sauvegarderClefPriveeFichier(int tailleTexteClair,CLEFPRIVEE clefprivee){
	FILE * fichier=creerFichier("Entrez le nom du fichier dans lequel sauvegarder la clef privee");
	char* aux;
	int i;
	
	aux=intToCarac(tailleTexteClair);
	fputs(aux,fichier);
	fputc('\n',fichier);
	free(aux);
	
	aux=intToCarac(clefprivee.N);
	fputs(aux,fichier);
	fputc('\n',fichier);
	free(aux);
	
	aux=intToCarac(clefprivee.Z);
	fputs(aux,fichier);
	fputc('\n',fichier);
	free(aux);
	
	aux=intToCarac(clefprivee.tailleSuite);
	fputs(aux,fichier);
	fputc('\n',fichier);
	free(aux);
	
	
	for(i=0;i<clefprivee.tailleSuite;i++){
		aux=intToCarac(*(clefprivee.permutation+i));
		fputc(' ',fichier);
		fputs(aux,fichier);
		free(aux);
	}
	fputc('\n',fichier);
	
	for(i=0;i<clefprivee.tailleSuite;i++){
		aux=intToCarac(*(clefprivee.suiteSuperCroissante+i));
		fputc(' ',fichier);
		fputs(aux,fichier);
		free(aux);
	}
	fputc('\n',fichier);
	
	fclose(fichier);
}

