#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "SaisirTexte.h"
#include "SauvegarderFichier.h"

char* chargerFichier(){
	FILE *fichier;
	char *nomfichier,*textePassage,*texte;
	
	textePassage=(char*)malloc(255*sizeof(char));
	nomfichier=saisirTexte("Veuillez entrez le nom du fichier que vous voulez charger\n"
			"Ce nom contiendra également l'arborescence du fichier s'il n'est pas dans le workspace!!");
	fichier=fopen(nomfichier,"r");
	free(nomfichier);
	fgets(textePassage,255,fichier);
	fclose(fichier);
	printf("Taille du texte %d\n",strlen(textePassage));
	texte=(char *) malloc ((strlen(textePassage)+1)*sizeof(char));
	strcpy(texte,textePassage);
	free(textePassage);
	printf("Voici le texte qui a été chargé :\n%s\n",texte);
	return texte;
}

int *  chargerFichierCrypt(int *nbrElements){
	char *pointeur,*chaine=chargerFichier();
	int i,*tabCrypt;
	*nbrElements=0;
	for(i=0;i<strlen(chaine);i++){
		if( *(chaine+i)==' ') (*nbrElements)++;
	}
	pointeur=chaine;
	tabCrypt=(int*)malloc(*nbrElements*sizeof(int));
	if(tabCrypt==NULL)printf("erreur mémoire\n");
	else{
		for(i=0;i<*nbrElements;i++){
			*(tabCrypt+i)=atoi(pointeur);
			pointeur=strchr(++pointeur,' ');
		}
	}
	free(chaine);
	return tabCrypt;
}

/*
int main(){
	char *message,*mess_charg;
	message=saisirTexte("Saisissez le texte à traiter!!");
	sauvegarderFichier(message);
	printf("Nous allons maintenant charger ce fichier!\n");
	mess_charg=chargerFichier();
	printf("Impression test : %s",mess_charg);
	return 1;
}
*/
