#include <stdio.h>
#include <stdlib.h>

#define TAILLE_SUITE 7


typedef enum{NON,OUI}BOOLEEN;

char* passerTabBinaireChaine(BOOLEEN * b,int NBR_BITS){
	char* chaine=(char*)malloc( (NBR_BITS+1)*sizeof(char) );
	*(chaine+NBR_BITS)='\0';
	int i;
	for(i=0;i<NBR_BITS;i++){
		*(chaine+i)=( *(b+i)==OUI )?'1':'0';
	}
	return chaine;
}

BOOLEEN * passerValeurTabBinaire(int valeur){
	int i,puissance_de_deux=128;
	BOOLEEN *b;
	b=(BOOLEEN *) malloc (7*sizeof(BOOLEEN));
	for(i=0;i<7;i++){
		puissance_de_deux/=2;
		*(b+i)=(valeur>=puissance_de_deux)?OUI:NON;
		valeur=valeur%puissance_de_deux;
	}
	//printf("Voici le mot binaire correspondant:\n%s\n",passerTabBinaireChaine(b));
	return b;
}

BOOLEEN * passerValeurTabBinaireDecryp(int valeur, int clePrivee[],int NBR_BITS){
	int i;
	BOOLEEN *b;
	b=(BOOLEEN *) malloc (NBR_BITS*sizeof(BOOLEEN));
	if(b==NULL){
		printf("Erreur malloc\n");
	}
	else{
		for(i=0;i<NBR_BITS;i++){
			if(valeur>=clePrivee[NBR_BITS-1-i]){
				*(b+NBR_BITS-1-i)=OUI;
				valeur-=clePrivee[NBR_BITS-1-i];
			}
			else *(b+NBR_BITS-1-i)=NON;
		}
	}
	//printf("Voici le mot binaire correspondant:\n%s\n",passerTabBinaireChaine(b));
	return b;	
}

int passerTabBinaireValeur(BOOLEEN * b){
	int i,valeur=0,puissance_de_deux=128;
	for(i=0;i<7;i++){
		puissance_de_deux/=2;
		valeur+=( *(b+i)==OUI )?puissance_de_deux:0;
	}
	return valeur;
}

int passerTabBinaireValeurCryptee(BOOLEEN * b,int clePublique[],int N,int NBR_BITS){
	int i,valeur=0;
	for(i=0;i<NBR_BITS;i++){
		valeur+=( *(b+i)==OUI )?clePublique[i]:0;
	}
	valeur=valeur%N;
	return valeur;
}


/*
int main(){
	BOOLEEN * b[3];
	printf("On va faire le passage binaire de 32,34,122\n");
	b[0]=passerValeurTabBinaire(32);
	b[1]=passerValeurTabBinaire(34);
	b[2]=passerValeurTabBinaire(122);
	printf("le mot binaire associé à:\n");
	printf("32 est: %s\n",passerTabBinaireChaine(b[0]) );
	printf("34 est: %s\n",passerTabBinaireChaine(b[1]) );
	printf("122 est: %s\n",passerTabBinaireChaine(b[2]) );
	printf("On va faire le passage inverse!!\n");
	printf("La valeur associée au mot binaire :\n");
	printf("%s est %d\n",passerTabBinaireChaine(b[0]),passerTabBinaireValeur(b[0]));
	printf("%s est %d\n",passerTabBinaireChaine(b[1]),passerTabBinaireValeur(b[1]));
	printf("%s est %d\n",passerTabBinaireChaine(b[2]),passerTabBinaireValeur(b[2]));
	return 1;
}*/
