#include <stdio.h>
#include <string.h>
#include <stdlib.h>

void nettoyerFluxStdin(char * s){
	int c;
	char *p = strchr (s, '\n');
	
	if (p == NULL)while((c=getchar())!= EOF && c!= '\n');
	else *p='\0';
}
#define MAX_CARACT 250

char* saisirTexte(char *affichage){
	char chaine[MAX_CARACT+1]; //MAX_CARACT+1 pour garder une place pour le \0 !!
	char* p; //p est le pointeur sur caractères que je vais renvoyer à la fonction saisirTexte!!!
	
	printf("%s\n(%d caractères max!!)\n",affichage,MAX_CARACT);
	fgets(chaine,MAX_CARACT,stdin);
	nettoyerFluxStdin(chaine);
	p=(char*) malloc ( (strlen(chaine)+1)*sizeof(char) );
	strcpy(p,chaine);
	return p;
}

int saisirEntier(char * affichage){
	char *chaine; 
	int i;
	printf("Entrez un entier\n");
	do{
		//fgets(chaine,6,stdin); on utilisera apres la fonction saisir texte qui aura été créée!!
		chaine=saisirTexte("");
		
		i=0;
		while( (i<strlen(chaine)) && (*(chaine+i)>='0') && (*(chaine+i)<='9') ) i++;
		/*Dans cette boucle on cherche juste à voir si l'on a bien une chaine composée
		uniquement de caracteres chiffres entre 0 et 9! Dans ce cas la on sort de la boucle
		apres avoir parcouru toute la chaine sinon on sort avant!! et cela explique la
		condition du "do while" -> Pour relancer une saisie incorrecte!! */
		
		if(i<strlen(chaine)) printf("Mauvaise saisie!! Ne saisissez que des entiers!!\n");
		//message d'erreur pour signaler une mauvaise saisie.
		
	}while(i<strlen(chaine));
	
	return atoi(chaine);//la fonction atoi renvoit l'entier correspondant à l'entier ecrit sous
	//forme de caractere dans une chaine passée en parametre!
}


/* Je suis passé par un pointeur sur une chaîne de caractères pour ne pas gâcher de l'espace mémoire 

int main(){
	char* z=saisirTexte();
	printf("%s",z);
	return 1;
}
*/
