#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "SaisirTexte.h"
#include "intToCarac.h"

void sauvegarderFichier(char* texte){
	FILE *fichier;
	char *nomfichier;
	int test=1;
	
	nomfichier=saisirTexte("Veuillez entrer le nom du fichier dans lequel vous voulez le sauvegarder(avec extension .txt)");
	//*(nomfichier+strlen(nomfichier))='.';
	//strcat(nomfichier,"txt");
	fichier=fopen(nomfichier,"w");  //Le fichier est ouvert en lecture et on a fait appel à la fonction
	                                   //saisieTexte pour demander à l'utilisateur d'écrire le nom du fichier!
	test=fputs(texte,fichier);
	if(test==EOF)printf("Il y a un problème à l'écriture du texte dans le fichier!!\n");
	else printf("Le texte a bien été enregistré!!\n\n");
	free(nomfichier);
	fclose(fichier);
}

void saveFichierCrypte(int *tabCryp,int longueur){
	FILE *fichier;
	char *nomfichier,*chaineCrypt;
	int i;
	
	nomfichier=saisirTexte("Veuillez entrer le nom du fichier dans lequel vous voulez le sauvegarder(avec extension .txt)");
	//*(nomfichier+strlen(nomfichier))='.';
	//strcat(nomfichier,"txt");
	fichier=fopen(nomfichier,"w");  //Le fichier est ouvert en lecture et on a fait appel à la fonction
	                                   //saisieTexte pour demander à l'utilisateur d'écrire le nom du fichier!
	free(nomfichier);
	for(i=0;i<longueur;i++){
		chaineCrypt=intToCarac( *(tabCryp+i) );
		fputs(chaineCrypt,fichier);
		fputc(' ',fichier);
		free(chaineCrypt);
	}
	fputc('\0',fichier);
	fclose(fichier);
}
/*
int main(){
	char *message;
	message=saisirTexte();
	sauvegarderFichier(message);
	return 1;
}
*/
