#ifndef CREATIONCLEFSPUBLIQUEPRIVEE_H_
#define CREATIONCLEFSPUBLIQUEPRIVEE_H_ extern

#endif /*CREATIONCLEFSPUBLIQUEPRIVEE_H_*/

#ifndef TEXTE_LONG
#define TEXTE_LONG 7
#endif


typedef	struct ClefPrivee{
	int tailleSuite;
	int *suiteSuperCroissante;
	int *permutation;
	int N;
	int Z;
}CLEFPRIVEE;

typedef struct ClefPublique{
						int tailleSuite;
						int *suitePermuteeNonSuperCroissante;
}CLEFPUBLIQUE;


CREATIONCLEFSPUBLIQUEPRIVEE_H_ CLEFPRIVEE * creerClefPrivee(int taille);
CREATIONCLEFSPUBLIQUEPRIVEE_H_ CLEFPUBLIQUE * creerClefPublique(CLEFPRIVEE *clefprivee);
CREATIONCLEFSPUBLIQUEPRIVEE_H_ int compression(char* *texte_A_Crypter);
CREATIONCLEFSPUBLIQUEPRIVEE_H_ int depression(char* *texte_A_Crypter);
CREATIONCLEFSPUBLIQUEPRIVEE_H_ int* permuter(int taille);
