#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define MAX_CARAC 300
#include "SaisirTexte_Entier.h"
#include "CreationClefsPubliquePrivee.h"
#include "PassageCaractereValeurCryptee.h"
#include "Fichiers.h"
#include "PassageEntierCaractere.h"

void cryptageApresSaisie(){
	
	char *textToCrypt=saisirTexte("Veuillez saisir le texte à crypter!",stdin,MAX_CARAC);
	//printf("%s:test 1\n",textToCrypt);
	int tailleClef=(strlen(textToCrypt)>TEXTE_LONG)?compression(&textToCrypt):depression(&textToCrypt);
	//printf("%s:test 2\n",textToCrypt);
	int longueurTexte=strlen(textToCrypt);
	
	//printf("Taille clef %d",tailleClef);
	
	CLEFPRIVEE * clefprivee=creerClefPrivee(tailleClef);
	//printf("Taille clef privee %d",clefprivee->tailleSuite);
	CLEFPUBLIQUE * clefpublique=creerClefPublique(clefprivee);
	
	int place=0;
	int *tabValeurCryptee;
	int i;
	char * valeurCryptee;
	//char *nomfichier
	FILE *fichier,*fichSaveClefPrivee;
	//fichier=creerFichier("Entrez le nom du fichier dans lequel sauvegarder(avec arborescence et extension si vous le souhaitez)",&fichSaveClefPrivee);
	
	char *nomfich=saisirTexte("entrez le nom du fichier",stdin,250);
	fichSaveClefPrivee=fopen(nomfich,"w");
	
	fwrite(clefprivee,sizeof(CLEFPRIVEE),1,fichSaveClefPrivee);
	fclose(fichSaveClefPrivee);
	
	char *nomfichier=saisirTexte("entrez le nom du fichier",stdin,250);
	FILE *fichClefprivee=fopen(nomfichier,"r");
	CLEFPRIVEE *privateKey;
	fread(privateKey,sizeof(CLEFPRIVEE),1,fichClefprivee);
	fclose(fichClefprivee);
	

	
	
	
	while(place<longueurTexte){
		tabValeurCryptee=motBinaireValeurCryptee(textToCrypt,clefpublique,&place);
		for(i=0;i<7;i++){
			//printf("%d ",*(tabValeurCryptee+i) );
			valeurCryptee=intToCarac( *(tabValeurCryptee+i) );
			fputs( valeurCryptee , fichier);
			fputc(' ',fichier);
			free(valeurCryptee);
		}
		free(tabValeurCryptee);
	}
	printf("\n\nTOUT A BIEN MARCHE!!\n\n");
	fclose(fichier);
	
}

