#include <stdio.h>
#include <stdlib.h>

extern int saisirEntier(char *,FILE *);
extern void cryptageDepuisFichier();
extern void cryptageApresSaisie();
extern int * creationAutomatiqueSuiteSuperCroissante(int taille,int *N,int *Z);
extern int * saisieSuiteSupercroissante(int taille,int *N,int *Z);

void menuCryptage(){
	int choix1;
	
		printf("------------------------------------\n");
		printf("-----------MENU CRYPTAGE------------\n");
		printf("------------------------------------\n\n\n");
		printf("Appuyez sur la touche correspondant à l'action désirée...\n\n");
		printf("1. Charger un texte à crypter\n");
		printf("2. Entrer soi même un texte à crypter\n");
		printf("0. Quitter!!\n\n");
		printf("Veuillez faire votre choix..\n");
		
		do{
			choix1=saisirEntier("",stdin);
			if((choix1!=1)&&(choix1!=2)&&(choix1!=0))printf("Erreur de saisie. L'entier a entrer doit être soit 1 soit 2 soit 0 !\nVeuillez recommencer!\n");
		}while((choix1!=1)&&(choix1!=2)&&(choix1!=0));
		
		switch(choix1){
			case 0:printf("Fin du programme\nMerci de l'avoir utilisé !");
			        exit(0);
			case 1: cryptageDepuisFichier();exit(0);
			        break;//Avec Chargement Fichier Texte
			case 2: cryptageApresSaisie();
			        break;//A Partir d'Un Texte Saisi
			default:printf("ERREUR-->Fermeture du programme\nMerci de l'avoir utilisé !");
			        exit(0);
		}
}

int* menuCreationSuiteSuperCroissante(int taille,int *N,int *Z){
	int choix2;
	int *aux;
	
		printf("------------------------------------\n");
		printf("------------CLEF PRIVEE-------------\n");
		printf("------------------------------------\n\n\n");
		printf("Appuyez sur la touche correspondant à l'action désirée...\n\n");
		printf("1. Laisser l'ordinateur créer une suite supercroissante\n");
		printf("2. Entrer soi même sa suite supercroissante\n");
		printf("0. Quitter!!\n\n");
		printf("Veuillez faire votre choix..\n");
		
		do{
			choix2=saisirEntier("",stdin);
			if((choix2!=1)&&(choix2!=2)&&(choix2!=0))printf("Erreur de saisie. L'entier a entrer doit être soit 1 soit 2 soit 0 !\nVeuillez recommencer!\n");
		}while((choix2!=1)&&(choix2!=2)&&(choix2!=0));
		
		switch(choix2){
			case 1: aux=creationAutomatiqueSuiteSuperCroissante(taille,N,Z);
			case 2: aux=saisieSuiteSupercroissante(taille,N,Z);
			default:printf("Fin du programme\nMerci de l'avoir utilisé !");
			        exit(0);
		}
		return(aux);
}
