#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define PASSAGECARACTEREVALEURCRYPTEE_H_
#include "PassageCaractereValeurCryptee.h" 


char* passerTabBinaireChaine(BOOLEEN * b,int NBR_BITS){
	char* chaine=(char*)malloc( (NBR_BITS+1)*sizeof(char) );
	*(chaine+NBR_BITS)='\0';
	int i;
	for(i=0;i<NBR_BITS;i++){
		*(chaine+i)=( *(b+i)==OUI )?'1':'0';
	}
	return chaine;
}

BOOLEEN* passageCaractereMotBinaire(char caractere){
	int valeurASCII=caractere;
	BOOLEEN *b=(BOOLEEN*)malloc(7*sizeof(BOOLEEN));
	int i,puissance_de_deux=128;
	for(i=0;i<7;i++){
		puissance_de_deux/=2;
		*(b+i)=(valeurASCII>=puissance_de_deux)?OUI:NON;
		if(*(b+i)==OUI)valeurASCII-=puissance_de_deux;
	}
	return b;
}

int* motBinaireValeurCryptee(char *texte_A_Crypter,CLEFPUBLIQUE *clefpublique,int *place){
		
		int i,bit;
		int *valeurCryptee=(int*)malloc(7*sizeof(int));
		
		BOOLEEN * booleen=(BOOLEEN*)malloc((clefpublique->tailleSuite*7)*sizeof(BOOLEEN));
		BOOLEEN *b;
		
		for(i=0;i<clefpublique->tailleSuite;i++){
			b=passageCaractereMotBinaire(*(texte_A_Crypter+*place));
			//printf("mot binaire n° %d est %s \n",i,passerTabBinaireChaine(b,7));
			for(bit=0;bit<7;bit++){
				*(booleen+bit+i*7)=*(b+bit);
			}
			(*place)++;
			free(b);
		}
		//printf("mot binaire final est %s \n",passerTabBinaireChaine(booleen,clefpublique->tailleSuite*7));
		
		int aux;
		i=0;
		while(i<7){
			bit=0;
			*(valeurCryptee+i)=0;
			//printf("valeur %d : ",i);
			while(bit<clefpublique->tailleSuite){
				aux=( (*(booleen+bit+i*clefpublique->tailleSuite))==OUI )?1:0;
				( *(valeurCryptee+i) ) += ( *(clefpublique->suitePermuteeNonSuperCroissante+bit) ) * aux;
				
				//printf("%d ",*(clefpublique->suitePermuteeNonSuperCroissante+bit));
				
				bit++;
			}
			
			//printf("\n valeur finale =  %d\n\n",*(valeurCryptee+i));
			
			i++;			
		}
		return(valeurCryptee);			
}
