#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "PassageCaractereValeurCryptee.h"
#include "EuclideEtendu.h"


BOOLEEN * passerValeurCrypTabBinaire(int valeurInversMod, int *suiteSuperCroissante,int tailleSuite){
	int i;
	BOOLEEN *b;
	b=(BOOLEEN*) malloc (tailleSuite*sizeof(BOOLEEN));
	if(b==NULL){
		printf("Erreur malloc\n");
	}
	else{
		for(i=0;i<tailleSuite;i++){
			if(valeurInversMod>=*(suiteSuperCroissante+tailleSuite-1-i)){
				*(b+tailleSuite-1-i)=OUI;
				valeurInversMod-=*(suiteSuperCroissante+tailleSuite-1-i);
			}
			else *(b+tailleSuite-1-i)=NON;
		}
	}
	//printf("Voici le mot binaire correspondant:\n%s\n",passerTabBinaireChaine(b));
	return b;	
}

void permutationTabBinaire(BOOLEEN *tabBool, int *suitePermutee,int tailleSuite ){
	int i;
	BOOLEEN *b=(BOOLEEN *)malloc(tailleSuite*sizeof(BOOLEEN));
	for(i=0;i<tailleSuite;i++){
		*(b+i)=*(tabBool+i);
	}
	for(i=0;i<tailleSuite;i++){
		*(tabBool+i)=*(b+ *(suitePermutee+i) );
	}
}

char passageMotBinaireCaractere(BOOLEEN *b){
	int valeurASCII=0;
	int i,puissance_de_deux=128;
	for(i=0;i<7;i++){
		puissance_de_deux/=2;
		if(*(b+i)==OUI)valeurASCII+=puissance_de_deux;
	}
	return valeurASCII;
}

char* motBinaireCaractereDecrypte(char* *place,CLEFPRIVEE clefprivee){
		
		int i,aux,bit;
		*place=strchr(*place,' ');
		char *portionDecryptee=(char*)malloc(clefprivee.tailleSuite*sizeof(char));
		
		BOOLEEN * booleen=(BOOLEEN*)malloc((clefprivee.tailleSuite*7)*sizeof(BOOLEEN));
		BOOLEEN *b;
		int inverseModulo=inverseModuloN(clefprivee.N,clefprivee.Z);
		
		for(i=0;i<7;i++){
			*place=strchr(*place,' ');
			aux=passageValeurCrypValeurInversMod(atoi(*place),inverseModulo,clefprivee.N);
			b=passerValeurCrypTabBinaire(aux,clefprivee.suiteSuperCroissante,clefprivee.tailleSuite);
			permutationTabBinaire(b,clefprivee.permutation,clefprivee.tailleSuite);
			
			for(bit=0;bit<clefprivee.tailleSuite;bit++){
				*(booleen+bit+i*clefprivee.tailleSuite)=*(b+bit);
			}
			free(b);
			(*place)++;
		}
		//printf("mot binaire final est %s \n",passerTabBinaireChaine(booleen,clefpublique->tailleSuite*7));
		
		i=0;
		while(i<clefprivee.tailleSuite*7){
			*(portionDecryptee+(i/7))=passageMotBinaireCaractere(booleen);
			i+=7;
		}
		return(portionDecryptee);			
}


