#include <stdio.h>
#include <string.h>
#include <stdlib.h>

extern char * intToCarac(int );//PassageEntierCaractere.c
extern void quitterExecution();//QuitterExecutionProgramme.c


void nettoyerFluxStdin(char * s){
	int c;
	char *p = strchr (s, '\n');
	
	if (p == NULL)while((c=getchar())!= EOF && c!= '\n');
	else *p='\0';
}


char* saisirTexte(char *affichage,FILE *file,int maxCaract){
	char chaine[maxCaract+1]; //maxCaract+1 pour garder une place pour le \0 !!
	char* p; //p est le pointeur sur caractères que je vais renvoyer à la fonction saisirTexte!!!
	
	char *t=intToCarac(maxCaract);
	char *affichageSuppl=(char*)malloc( (strlen(t)+strlen(" caracteres max.")+2) * sizeof(char));
	char *c;
	c=affichageSuppl;
	*affichageSuppl='\n';
	affichageSuppl=strcat(affichageSuppl,t);
	affichageSuppl=strcat(affichageSuppl," caracteres max.");
	affichageSuppl=strcat(affichageSuppl,"\n");
	printf("%s%s",affichage,(affichage=='\0')?"":affichageSuppl);
	free(c);
	free(t);
	
	fgets(chaine,maxCaract,file);
	if(file==stdin)nettoyerFluxStdin(chaine);
	p=(char*) malloc ( (strlen(chaine)+1)*sizeof(char) );
	strcpy(p,chaine);
	return p;
}


int saisirEntier(char * affichage,FILE *f){
	char *chaine; 
	int i,longueurChaine,entierCorrespondant,compteur=0;
	
	do{
		chaine=saisirTexte( (compteur>0)?"":affichage ,f ,10);
		longueurChaine=strlen(chaine);
		compteur++;
		
		i=0;
		while( (i<longueurChaine) && (*(chaine+i)>='0') && (*(chaine+i)<='9') ) i++;
		/*Dans cette boucle on cherche juste à voir si l'on a bien une chaine composée
		uniquement de caracteres chiffres entre 0 et 9! Dans ce cas la on sort de la boucle
		apres avoir parcouru toute la chaine sinon on sort avant!! et cela explique la
		condition du "do while" -> Pour relancer une saisie incorrecte!! */
		
		if(i==longueurChaine) entierCorrespondant=atoi(chaine);
		//la fonction atoi renvoit l'entier correspondant à l'entier ecrit sous
		//forme de caractere dans une chaine passée en parametre!
		free(chaine);
		
		if(i<longueurChaine){
			printf("Mauvaise saisie!! Ne saisissez que des entiers!!\n");
			//message d'erreur pour signaler une mauvaise saisie.
			if(compteur>=5)quitterExecution();//Une alternative pour l'utilisateur!
		}	
		
	}while(i<longueurChaine);
	
	return entierCorrespondant;
}
/*
int main(){
	printf("Petit test\n");
	printf("%d",saisirEntier("",stdin));
	return 1;
}*/
